Description

Related issues:

Related to Base Language - Feature #2063: Support negative numbers defined wi... Closed 02/27/2013

History

#1 - 02/27/2013 12:14 PM - Greg Shah

For details, please see notes 6 and 7 of #2063.

#2 - 03/06/2013 01:25 PM - Greg Shah

- File date_literals_vs_dec_literals.p added

The following testcase shows the limits of this ambiguity.

From the header:

/* date literals can use a . (and -) as a separator; this can occur in ways that */

/* overlap with decimal usage (the same literal input can be both a date and a */

/* decimal; this testcase explores the limits of this behavior */

/* Months: */

/* can't just specify the month */

/* have to be between 1 and 12 inclusive */

/* can be zero padded, there seems to be no practical limit so this is probably dropped */

/* for literals, is always in the first (leftmost) position, no matter what the SESSION:DATE-FORMAT */

/* Days: */

/* have to be between 1 and the highest day of the corresponding month inclusive */

/* can be zero padded, there seems to be no practical limit so this is probably dropped */

/* for literals, is always in the second (middle if there is a year) position, no matter what the SESSION:DATE

-FORMAT */

/* Year: */

/* this is optional */

/* for literals, is always in the third (last) position, no matter what the SESSION:DATE-FORMAT */

/* if present, then the date cannot be confused with a decimal literal, so we aren't testing those cases here 

*/

/* most importantly: these "special" date forms can only be used inside a variable */

/* definition initializer!  when encountered in regular code, they are exclusively */

/* treated as decimal literals */
#3 - 03/08/2013 10:48 AM - Greg Shah

- Target version set to Milestone 4

- File date_literals_vs_dec_literals.p added

- Assignee set to Greg Shah

- File ges_upd20130308a.zip added

Updated version of the testcase plus the prepared fixes which are going into conversion testing now.

The core solution is about disabling date literal processing in these cases of a DIGITS.DIGITS- and always making it a decimal literal.  Then in the var

def initializer processing, we detect when this is a date var and we rewrite the decimal literals to be date literals.

Please note that this also includes many other fixes for date, num and dec literal processing.  Included are improvements to removing zero padding

like the 4GL does and better handling of 64-bit literals.

#4 - 03/08/2013 10:56 AM - Greg Shah

- File ges_upd20130308b.zip added

Fixed a stupid indexing error.  Going back into conversion testing.

#5 - 03/08/2013 12:12 PM - Greg Shah

- File ges_upd20130308c.zip added

Another silly mistake, I didn't properly exclude num literals from the trailing zero removal.  This updated version is back in conversion testing.  I don't

expect further problems.

#6 - 03/08/2013 02:05 PM - Greg Shah

- File ges_upd20130308d.zip added

- Status changed from New to WIP

How many times am I going to be wrong today?  Majic compiled fine with the c update but there are still many unwanted removals of zero padding. 

This version resolves those cases.  It has gone back into conversion testing.

#7 - 03/08/2013 03:28 PM - Greg Shah

- File ges_upd20130308e.zip added

Final version going through conversion testing now.  There was an issue with removal of zeros from the year portion of a date (it affected 1 place in

Majic).

#8 - 03/08/2013 03:38 PM - Constantin Asofiei

Another issue related to dates:

def var d as date init "".

converts to:

  date d = ""; /* compiler error !! */
#9 - 03/08/2013 04:30 PM - Greg Shah

Passed conversion testing and checked in as revision 10269.

I'll handle the date from an empty string next.

#10 - 03/08/2013 05:05 PM - Greg Shah

- File ges_upd20130308f.zip added

Fix for empty string used as a date var initializer.  It is being conversion tested now.

#11 - 03/09/2013 11:06 AM - Greg Shah

Passed conversion testing and checked in as bzr revision 10272.

#12 - 03/09/2013 11:06 AM - Greg Shah

- Status changed from WIP to Closed

#13 - 03/13/2013 02:33 PM - Constantin Asofiei

- File ca_upd20130313g.zip added

- File ca_upd20130312f.zip added

The only remaining problem was with char field initializers, which were not handled (it was parsers fault). The notes 113, 114, 116,199 in #2068:

- CA:

One more issue related to initializers. Following is valid in 4GL:

 

def temp-table tt1 field f1 as char init 0.

- GES:  

The places where we "coerce" incompatible types that are used in initializers are in:

1. progress.g in the initializer_constant rule

2. Variable.booleanManhandle()

 

- CA:

Actually, there is another place where this is done, for character variables: in fixups/variable_initializers. I've tested the date/int/dec/log/char

cases (in both fields and vars) and the only problem was to char fields. The solution is to fix the progress.g's initializer_constant rule, to enclose

the literal in quotes, if this is a char and the literal is not string or unknown_val. With this, we can remove the fixups in variable_initializers.

 

I'm putting this through conversion regression testing.
#14 - 03/13/2013 03:15 PM - Constantin Asofiei

The update has passed conversion regression testing.

#15 - 03/14/2013 08:13 AM - Greg Shah

I think the wrong update is posted here.

#16 - 03/14/2013 09:56 AM - Constantin Asofiei

- File ca_upd20130313f.zip added

Correct, good letter, wrong date. Attached is the good one.

#17 - 03/14/2013 09:56 AM - Constantin Asofiei

- File deleted (ca_upd20130312f.zip)

#18 - 03/14/2013 10:27 AM - Greg Shah

The update looks good.  You can check it in and distribute it.

#19 - 03/14/2013 12:04 PM - Constantin Asofiei

Committed to bzr revision 10285.

#20 - 11/16/2016 10:58 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

Files

date_literals_vs_dec_literals.p 12.9 KB 03/06/2013 Greg Shah

ges_upd20130308a.zip 360 KB 03/08/2013 Greg Shah

date_literals_vs_dec_literals.p 13.1 KB 03/08/2013 Greg Shah

ges_upd20130308b.zip 360 KB 03/08/2013 Greg Shah

ges_upd20130308c.zip 360 KB 03/08/2013 Greg Shah

ges_upd20130308d.zip 361 KB 03/08/2013 Greg Shah

ges_upd20130308e.zip 361 KB 03/08/2013 Greg Shah

ges_upd20130308f.zip 267 KB 03/08/2013 Greg Shah

ca_upd20130313g.zip 700 Bytes 03/13/2013 Constantin Asofiei

ca_upd20130313f.zip 268 KB 03/14/2013 Constantin Asofiei
